clear all;
load('configuration.mat');
SECONDs     = 1;
ARTI_DOA    = 129;
window = eval( [conf.WINDOW,'(', num2str(conf.N),')''*',num2str(conf.WINDOW_COEF),';'] );


fid = fopen( 'artificial_signal.bin','w' );
for i = 1 : SECONDs
    %SIGNAL & NOISE
    Fo = ( conf.BANDPASS(1)+conf.BANDPASS(2) )/2 ;
    t = 0:1/conf.Fs:(conf.N-1)/conf.Fs ;
    y = 0.08*sin(2*pi*Fo*t);
    noise = zeros( conf.MIC_NUM, conf.N );
    total = zeros( conf.MIC_NUM, conf.N );
    for j =1:conf.MIC_NUM
        noise(j,:) = wgn(1, conf.N, -40); 
        total(j,:) = noise(j,:) + y; 
    end
    %FFT
    freq_total = zeros( conf.MIC_NUM, conf.N );
    for j = 1 : conf.MIC_NUM
        freq_total(j,:) = fft(total(j,:).*window)/conf.N;
    end
    freq_noise = fft(noise, [], 2)/conf.N;
    freq_sign  = fft(y, [], 2)/conf.N;
    %SIMULATE DELAY
    [phase,~,~] = BFphase( conf .Fs, conf.N, ARTI_DOA);
    delay = (phase-phase(1))*conf.Fs;
    coef = (2*pi*delay*(1:conf.Fs))/conf.N;
    freq_delayed = freq_total.*exp(-1i * coef);
    time_delayed = zeros( conf.MIC_NUM, conf.N );
    for j = 1 : conf.MIC_NUM
        time_delayed(j,:) = ifft( freq_delayed(j,:)*conf.N )./window;
    end
    %SNR
    [ POWER_SIG, POWER_NOI, SNR, OPTI_SNR ] = getSnr( freq_delayed, conf.Fo, conf.Fs/conf.N, 'degree', 129, 'on');
    %Write into a binary file
%     fwrite(fid, single( real(freq_delayed) ), 'single');   
%     fwrite(fid, single( imag(freq_delayed) ), 'single');
    fwrite(fid, single( real(time_delayed) ), 'single');
end
fclose(fid);

