if (iteration == 0)
    clear all;
    stop=0;
    load('configuration.mat');
    %filter
%     [b,a] = butter(2,0.006,'high');
%     filter_arg = {b;a};
%     b = fir1(4000,0.006,'high');
%     figure,freqz(b,1);
%     filter_arg = {b;1};
    filter_window = 500;
    b = fir2(filter_window,[0, 0.006, 0.01, 1], [0 0 1 1]);
    filter_arg = {b;1};
    data_rear = zeros(conf.MIC_NUM , filter_window);
    %lag_table
    if( conf.MODE==4 )
        lagTable = conf.LAG_TABLE;
    end
    %build connection
    channel_list = [];
    if( conf.IS_TEAMWORK==1 )
        [status, ip_list] = connInit( 'windows', 'manager' );
        if( status~=0 ) % if fail to initialize connection
            stop=1;
            return;
        end
        [channel_list,worker_num] = connBuild( ip_list, conf.PORT_LIST, 'Server' );
    end
else
%     pre_data = mics(1,:)
    longer_mics = getFiltered( filter_arg, [data_rear, mics] );
    new_mics = longer_mics(:, filter_window+1 : end);
    if( conf.MODE==3 )
        lagTable = getLagTable(new_mics);
    end
    ADJ_DATA =  getAdjusted(new_mics, lagTable, 'time', conf.Fs/conf.N);
    post_data = sum(ADJ_DATA)/conf.MIC_NUM;
    sound( post_data(1,:), conf.N );
    if( conf.IS_TEAMWORK==1 )
        [~,worker_num] = size(channel_list);
        %Distribute
        for i = 1 : worker_num
            connSend( channel_list(i), 1, [1 1], 'integer' );     %send order
            for seg_index = 1 : conf.N/conf.AU_SEG_LENGTH
                connSend(channel_list(i), single(ADJ_DATA(1,conf.AU_SEG_LENGTH*(seg_index-1)+1:conf.AU_SEG_LENGTH*seg_index)), [1 conf.AU_SEG_LENGTH], 'single');
            end
        end
    end
    data_rear = mics(:,conf.N-filter_window+1:end);
end
if (stop == 1&&conf.IS_TEAMWORK==1 )
    % disconnect workers
    for i = 1 : worker_num
        connSend( channel_list(i), 0, [1 1], 'integer' );     %connSend order     %task is done
    end
    connDestroy( channel_list );
end