%% Mode
isTeamwork  = 0;    % 1 or 0;
mode        = 3;    % 1=from_record_file ; 2=from_simulation_file; 3=real_time_single_source; 4=real_time_multiple_source
switch( mode )
    case 1
%         source = 'C:/temp/uPhoneArray_LoudSignal.bin';
%         source = 'C:/temp/uPhoneArray_sin4000.bin';
%         source      = 'C:\temp\uPhoneArray_Realtimtest.bin';
%         source      = 'C:/temp/uPhoneArray_Elvissin4000.bin';
        source      = 'C:/temp/uPhoneArray_speech1.bin';
        lag_table   = [];
    case 2
        source      = 'artificial_newPower.bin';
        lag_table   = [];
    case 3
        source      = [];
        lag_table   = [];
    case 4
        %in this case, modify saveLagTable.m and run it to 
        %make a lagTable for current layout of microphone array
        source      = [];
        load('lagTable.mat');
        lag_table = lagTable;
end

%% For simulation
object_freq = 2000;     % The frequency of signal in simulation

%% Constant
bandpass    = [3995 4005];
% mic_num     = 16;
mic_num = 16;
resolution  = 1;
n           = 50000;    %Fn
sampleRate  = 50000;
mic_dist    = 0.017;    %The distance between two mics is 1.7cm
audio_seg_length = 5000;

%% IP & PORT
ip_record_filename = 'temp_ipList.txt'; %don't change; dynamically record the involving workers
port_list = (4445:4460)';

% Manager_IP
BRY316_MANAGER = '172.16.1.245';
LOP214_MANAGER = '172.16.1.192';
LOP401_MANAGER = '172.16.0.136';
current_manager= BRY316_MANAGER;


%% FFT
window_selection = 'hanning';
if ( strcmp(window_selection,'hanning') )
    window_coefficient = 1.633;
elseif( strcmp(window_selection,'blackman') )
    window_coefficient = 1.812;
    disp('ATTENTION!');
    disp('You choose a blackman window.');
    disp('It may result in unexpecting errors in ''arti_sig_generator.m'' when generating a simulant signal in time domain.');
else
    warning('Configuration update fails due to an inappropriate window selection. Please check and rebuild.');
    return;
end


%% Struct
conf = struct(                                  ...
            'N',            n,                  ...
            'Fs',           sampleRate,         ...
            'BANDPASS',     bandpass,           ...
            'MIC_NUM',      mic_num,            ...
            'MIC_DIST',     mic_dist,           ...
            'AU_SEG_LENGTH',audio_seg_length,   ...
            'RESOLUTION',   resolution,         ...
            'MANAGER_IP',   current_manager,    ...
            'IP_RECORD',    ip_record_filename, ...
            'PORT_LIST',    port_list,          ...
            'IS_TEAMWORK',  isTeamwork,         ...
            'MODE',         mode,               ...
            'SOURCE_FILE',  source,             ...
            'LAG_TABLE',    lag_table,          ...
            'WINDOW',       window_selection,   ...
            'WINDOW_COEF',  window_coefficient, ...
            'Fo',           object_freq         ...
        );
%% Save
save('configuration.mat','conf');