function [ CHANNEL_LIST, CHANNEL_NUM ] = connBuild( IP_LIST, PORT_LIST, ROLE )
%BUILDCONN Return server channels built by given ip and port

[~,ip_num] = size(IP_LIST);
[port_num,~] = size(PORT_LIST);
CHANNEL_NUM = min(ip_num,port_num);
% CHANNEL_LIST = tcpip.empty( CHANNEL_NUM, 0 );
% CHANNEL_LIST = ObjectArray( zeros(CHANNEL_NUM,1) );
CHANNEL_LIST = [];
for i = 1 : CHANNEL_NUM
    if( strcmp(class(IP_LIST),'cell') )
        channel = tcpip( IP_LIST{i}(1,:), PORT_LIST(i), 'NetworkRole', ROLE );
    else
        channel = tcpip( IP_LIST(1,:), PORT_LIST(i), 'NetworkRole', ROLE );
    end
    set( channel,'OutputBufferSize',1024*40 );
    set( channel,'InputBufferSize', 1024*40);
    set( channel,'Timeout',10);
    if ( strcmp(ROLE,'Server') )
        fopen( channel );
    elseif ( strcmp(ROLE,'Client') )
        fopen_success = 0;
        while( fopen_success==0 )
            try 
                fopen( channel );
                fopen_success = 1;
            catch
            end
        end
    end
    CHANNEL_LIST = [ CHANNEL_LIST, channel ];
end
disp( ['Open ', num2str(CHANNEL_NUM), ' ', ROLE, ' channels'] );

end

