function [ TIME_DOMAIN_DATA ] = getDataBySecond( FILE_ID, SECOND )
%GETDATABYSECOND2 To reach the data of a certain second
%SECOND --- The second of interest. 0 or a negative number means reading 
%           from the beginning to the end.
%FILE_ID --- The id of the data file.


CURR_SECOND = floor( SECOND );
TIME_DOMAIN_DATA = [];
if( CURR_SECOND<1 )
    A = fread(FILE_ID,[1 2],'uint32','b');
    if ~isempty(A)
        TIME_DOMAIN_DATA = single( fread(FILE_ID,fliplr(A),'single','b') )';
    else
        while( ~feof(FILE_ID)&&isempty(A) )
            A = fread(FILE_ID,[1 2],'uint32','b');
        end
        if( ~feof(FILE_ID) )
            TIME_DOMAIN_DATA = single( fread(FILE_ID,fliplr(A),'single','b') )';
        end
    end
    return;
else
    frewind(FILE_ID);
    A = fread(FILE_ID,[1 2],'uint32','b');
    status = fseek(FILE_ID, (2+A(1)*A(2))*4*(CURR_SECOND-1), 'bof');
    if( status==-1||feof(FILE_ID) )    %fseek fails or reach the end of file
        disp(['File has less than ', int2str(CURR_SECOND),' seconds of data.']);
        return;
    else
        A = fread(FILE_ID,[1 2],'uint32','b');
        if ~isempty(A)
            TIME_DOMAIN_DATA = single( fread(FILE_ID,fliplr(A),'single','b') )';
        end
    end
end



end

