function [ FILTERED_DATA ] = getFiltered( FILTER_ARG, DATA )
%GETFILTERED Get the original data filtered
%INPUT:
%DATA --- Original data.
%FILTER --- Filter array.
%
%OUTPUT:
%FILTERED_DATA --- Filtered data.



FILTERED_DATA = DATA;
[rows, cols_D] = size(DATA);
[~   , cols_F] = size(DATA);
if( rows==0 )
    return;
elseif( cols_D~=cols_F )
    warning('Dimentions of original data and filter do not match');
    return;
end
for i = 1 : rows
    FILTERED_DATA(i,:) = filter( FILTER_ARG{:}, DATA(i,:) );
end


end

