function [ TABLE ] = getLagTable( DATA )
%GETLAGTABLE Make a lag table for each microphone comparing to mic_0. A
%negative value means the corresponding wave is prior to mic_0.
%
%INPUT:
%DATA --- The data in time domain
%
%OUPUT:
%TABLE --- The lag table. ( In second )

TABLE = [];
load('configuration.mat');
[rows,cols] = size(DATA);
if( rows*cols==0 )
    return;
end
corr_res = zeros(rows, cols*2-1);
for i = 1 : rows
    [corr_res(i,:), ~] = xcorr(DATA(1,:),DATA(i,:),'unbiased');
end
% single_side_width = floor( conf.MIC_DIST*16*sqrt(2)/340*cols );
single_side_width = floor( conf.MIC_DIST*15/340*cols );
if( single_side_width<1 )
    single_side_width = round( cols/5 );
end
[~,index] = max( corr_res(:, cols-single_side_width:cols+single_side_width), [], 2 );
TABLE = single_side_width + 1  - index;


end

