%make sure running 'manager.m' on manager computer only after
%the worker computers are running 'worker.m' and waiting


clc;clear all;
load('configuration.mat');
iter = 1;
DOA_HISTORY = [];
server_channel = [];
window = eval( [conf.WINDOW,'(', num2str(conf.N),')''*',num2str(conf.WINDOW_COEF),';'] );
% firmpm_arg = firpmord([250 300],[0 1],[0.01 0.1],50000,'cell');
% filter_arg = firpm(firmpm_arg{:});
filter_window = 500;
b = fir2(filter_window,[0, 0.006, 0.01, 1], [0 0 1 1]);
filter_arg = {b;1};
% [b,a] = butter(3,0.01,'high');

%% Read Form File
fileId = fopen( conf.SOURCE_FILE );


%% Make workers connected (optional)
if( conf.IS_TEAMWORK==1 )
    [status, ip_list] = connInit( 'windows', 'manager' );
    if( status~=0 ) % if fail to initialize connection
        return;
    end
    [server_channel,worker_num] = connBuild( ip_list, conf.PORT_LIST, 'Server' );
    % Tell workers the total number of involved workers 
    for i = 1 : worker_num
        connSend( server_channel(i), worker_num, [1 1], 'integer' );     %tell workers how many workers are involved
    end
end

%% Analyze
while (~feof(fileId))
    if( conf.MODE==1 )
        mics = getDataBySecond(fileId, 0);  % <1 means reading from the beginning
        if( isempty(mics) )
            break;
        end
%         mics1 = getFiltered( filter_arg, mics);
%         result = filter(b,a,mics(1,:));
        lagTable = getLagTable(mics);
        % FFT
        file = zeros(conf.MIC_NUM,50000);
        for i = 1:conf.MIC_NUM
            file(i,:) = fft(mics(i,:).*window)/conf.N;
        end
    elseif( conf.MODE==2 )
%         file_real = fread(fileId, [64 50000], 'single');
%         file_imag = fread(fileId, [64 50000], 'single');
%         file = file_real + 1i*file_imag;
%         if( isempty(file) )
%             continue;
%         end
        mics = fread(fileId, [64 50000], 'single');
        if( isempty(mics) )
            disp('The data of this second is empty');
            continue;
        end
        % FFT
        file = zeros(64,50000);
        for i = 1:64
            file(i,:) = fft(mics(i,:).*window)/conf.N;
        end
    end
    
    %Bandpass filter
    filtered_data = file( : , conf.BANDPASS(1):conf.BANDPASS(2) );
    %DOA
    [status, DOA] = getDoa( filtered_data, conf.IS_TEAMWORK, server_channel );
    if( status~=0 ) % if fail to getDOA
        disp('Cannot get DOA for this second!');
        continue;
    end
    fprintf( '%d.DOA = %d\n', iter, DOA );
    DOA_HISTORY = [ DOA_HISTORY, DOA ];
    
    iter = iter + 1;
    %SNR
%     [ POWER_SIG1, POWER_NOI1, SNR1, OPTI_SNR1 ] = getSnr( file, conf.BANDPASS, conf.Fs/conf.N, 'degree', DOA, 'on');
    [ POWER_SIG2, POWER_NOI2, SNR2, OPTI_SNR2 ] = getSnr( file, conf.BANDPASS, conf.Fs/conf.N, 'lag_time', lagTable, 'on');
%     bb = corrcoef(mics');
end
fclose(fileId) ;
figure;
plot(DOA_HISTORY,'x-b');


%% Release workers if connected before(optional)
if( conf.IS_TEAMWORK==1 )
    for i = 1 : worker_num
        connSend( server_channel(i), 0, [1 1], 'integer' );     %send order     %task is done
    end
    connDestroy( server_channel );
end