if (iteration == 0)
    clear all;
    stop=0;
    load('configuration.mat');
    load('angle_mic_table.mat');
    angle_history = [];
    server_channel = [];
    window = eval( [conf.WINDOW,'(', num2str(conf.N),')''*',num2str(conf.WINDOW_COEF),';'] );
    if( conf.IS_TEAMWORK==1 )
        [status, ip_list] = connInit( 'windows', 'manager' );
        if( status~=0 ) % if fail to initialize connection
            stop=1;
            return;
        end
        [server_channel,worker_num] = connBuild( ip_list, conf.PORT_LIST, 'Server' );
        % Tell workers the total number of involved workers 
        for i = 1 : worker_num
            connSend( server_channel(i), worker_num, [1 1], 'integer' );     %send order     %task is done
        end
    end
else
    file = zeros(64,50000);
    for i = 1:64
        file(i,:) = fft(mics(i,:).*window)/conf.N;
    end
    %Bandpass filter
    filtered_data = file( :,conf.BANDPASS(1):conf.BANDPASS(2) );
    %DOA
    [status, DOA] = getDoa( filtered_data, conf.IS_TEAMWORK, server_channel );
    an = DOA;
    angle_history = [ angle_history, DOA ];
end
if (stop == 1)
    % disconnect workers
    for i = 1 : worker_num
        connSend( server_channel(i), 0, [1 1], 'integer' );     %connSend order     %task is done
    end
    connDestroy( server_channel );
end
