% Make sure running 'worker_speaker.m' before 'aduioPlay_RealTime.m'
% Each worker works as below:
% 1. Build connection to Manager(audioPlay_RealTime)
% 2. connReceive the data from Manager
% 3. play the sound worker receives
% 4. Wait for the order from Manager, either to go to Step 2 or to quit


%% Initialize
clc; clear all;
%A struct variable conf will be loaded that contain.
load('configuration.mat');
% windows or mac; worker or manager (both case insensitive)
[status, myId] = connInit('windows', 'worker'); 
if( status~=0 ) % if fail to initialize connection
    return;
end


%% start
%build connection to Manager as a Client in TCP/IP
%will wait until connection has been built.
tClient = connBuild( conf.MANAGER_IP, conf.PORT_LIST(myId), 'Client' );
order = connReceive(tClient, [1 1], 'integer');
disp('I am working');
audio_orig = zeros(1, conf.N);
while( order==1 ) %1: have data to come;  0:done
    for i = 1 : conf.N/conf.AU_SEG_LENGTH
        audio_orig(1,conf.AU_SEG_LENGTH*(i-1)+1:conf.AU_SEG_LENGTH*i) = connReceive(tClient, [1 conf.AU_SEG_LENGTH], 'single');
    end
    sound( audio_orig(1,501:end), 50000-500);
    order = connReceive(tClient, [1 1], 'integer');
end


%% Finish
disp('My task has been done');
connDestroy( tClient );
